Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['', ''], ['', '']);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _graphqlTag = require('graphql-tag');

var _graphqlTag2 = _interopRequireDefault(_graphqlTag);

var _babylon = require('babylon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function (_ref) {
  var t = _ref.types;
  return {
    visitor: {
      ImportDeclaration: {
        exit: function exit(curPath, state) {
          var importPath = curPath.node.source.value;
          if (importPath.endsWith('.graphql') || importPath.endsWith('.gql')) {
            var buildInlineVariable = function buildInlineVariable(graphqlAST) {
              var babelAST = (0, _babylon.parse)('const obj = ' + JSON.stringify(graphqlAST));
              var objExp = babelAST.program.body[0].declarations[0].init;
              return t.variableDeclarator(t.identifier(curPath.node.specifiers[0].local.name), t.objectExpression(objExp.properties));
            };

            var query = createQuery(importPath, state.file.opts.filename);
            query.processFragments();
            query.dedupeFragments();
            query.parse();
            query.makeSourceEnumerable();
            curPath.replaceWith(t.variableDeclaration('const', [buildInlineVariable(query.ast)]));
          }
        }
      }
    }
  };
};

function createQuery(queryPath, babelPath) {
  var absPath = _path2.default.resolve(_path2.default.dirname(babelPath), queryPath);
  var source = _fs2.default.readFileSync(absPath).toString();
  var ast = null;
  var fragmentDefs = [];

  return {
    processFragments: function processFragments() {
      var imports = source.split(_os2.default.EOL).filter(function (line) {
        return line.startsWith('#import');
      });
      imports.forEach(function (statement) {
        var fragmentPath = statement.split(' ')[1].slice(1, -1);
        var absFragmentPath = _path2.default.resolve(_path2.default.dirname(absPath), fragmentPath);
        var fragmentSource = _fs2.default.readFileSync(absFragmentPath).toString();
        fragmentDefs = [].concat(_toConsumableArray(fragmentDefs), _toConsumableArray((0, _graphqlTag2.default)(_templateObject, fragmentSource).definitions));
      });
    },
    dedupeFragments: function dedupeFragments() {
      var seenNames = {};
      fragmentDefs = fragmentDefs.filter(function (def) {
        if (def.kind !== 'FragmentDefinition') return true;
        return seenNames[def.name.value] ? false : seenNames[def.name.value] = true;
      });
    },
    parse: function parse() {
      var parsedAST = (0, _graphqlTag2.default)(_templateObject, source);
      parsedAST.definitions = [].concat(_toConsumableArray(parsedAST.definitions), _toConsumableArray(fragmentDefs));
      ast = parsedAST;
    },
    makeSourceEnumerable: function makeSourceEnumerable() {
      var newAST = JSON.parse(JSON.stringify(ast));
      newAST.loc.source = ast.loc.source;
      ast = newAST;
    },

    get ast() {
      return ast;
    }
  };
}